%bcond_with gtk2
%bcond_with php
%bcond_with guile
%bcond_with bootstrap

%global SHARP  0
%global ARRRR  0
%global DEVIL  0
%global GTS    0
%global LASI   0
%global OCAML  0
%global QTAPPS 0
%global MING   0
%global SMYRNA 0
%global JAVA   1
%global GOLANG 1

%if %{with php}
%global PHP 1
%else
%global PHP 0
%endif

%if %{with guile}
%global GUILE 1
%else
%global GUILE 0
%endif

%global pluginsver 6
%global php_extdir %(php-config --extension-dir 2>/dev/null || echo %{_libdir}/php4)
%if "%{php_version}" < "5.6"
%global ini_name     %{name}.ini
%else
%global ini_name     40-%{name}.ini
%endif


Summary:		Graph Visualization Tools
Name:			graphviz
Version:		9.0.0
Release:		3%{?dist}
License:		EPL-1.0
URL:			http://www.graphviz.org/
Source0:		https://gitlab.com/api/v4/projects/%{name}%2F%{name}/packages/generic/%{name}-releases/%{version}/%{name}-%{version}.tar.xz

Patch0001:              graphviz-9.0.0-doxygen-fix.patch
Patch0002:              CVE-2023-46045-gvc-detect-plugin-installation-failure-and-display-a.patch
Patch3000:              graphviz-4.0.0-gvpack-neato-static.patch

BuildRequires:		make automake autoconf gcc-g++ bison m4 flex libtool libtool-ltdl-devel
BuildRequires:		zlib-devel libpng-devel libjpeg-devel fontconfig-devel expat-devel tk-devel
BuildRequires:          libXt-devel libXmu-devel libXaw-devel libXext-devel libSM-devel
BuildRequires:		pango-devel gmp-devel gd-devel librsvg2-devel urw-base35-fonts
BuildRequires:		python3-devel java-devel javapackages-tools lua-devel perl-devel
BuildRequires:		perl-Carp perl-ExtUtils-Embed perl-generators
BuildRequires:          ruby-devel ruby
BuildRequires:          golang
BuildRequires:		freetype-devel >= 2
BuildRequires:		tcl-devel >= 8.3
BuildRequires:		cairo-devel >= 1.1.10
BuildRequires:		swig >= 1.3.33

%if %{without bootstrap}
BuildRequires:          doxygen
%endif
%if %{with gtk2}
BuildRequires:          gtk2-devel
%endif
%if %{GUILE}
BuildRequires:		guile-devel
%endif
%if %{PHP}
BuildRequires:		php-devel
%endif
%if %{SHARP}
BuildRequires:		mono-core
%endif
%if %{DEVIL}
BuildRequires:		DevIL-devel
%endif
%if %{ARRRR}
BuildRequires:		R-devel
%endif
%if %{OCAML}
BuildRequires:		ocaml
%endif
%if %{QTAPPS}
BuildRequires:		qt-devel
%endif
%if %{GTS}
BuildRequires:		gts-devel
%endif
%if %{LASI}
BuildRequires:		lasi-devel
%endif
%if %{SMYRNA}
BuildRequires:          libglade2-devel
BuildRequires:          gtkglext-devel
%endif


Requires:		urw-base35-fonts
Requires:		xorg-x11-fonts-ISO8859-1-100dpi


%description
A collection of tools for the manipulation and layout of graphs (as in nodes
and edges, not as in barcharts).


%package devel
Summary:		Development package for graphviz
Requires:               pkgconfig
Requires:		%{name} = %{version}-%{release}
Requires:		%{name}-gd = %{version}-%{release}

%description devel
This package contains development files for graphviz.


%if %{DEVIL}
%package devil
Summary:		Graphviz plugin for renderers based on DevIL
Requires:		%{name} = %{version}-%{release}

%description devil
Graphviz plugin for renderers based on DevIL. (Unless you absolutely have
to use BMP, TIF, or TGA, you are recommended to use the PNG format instead
supported directly by the cairo+pango based renderer in the base graphviz rpm.)
%endif


%package doc
Summary:		PDF and HTML documents for graphviz

%description doc
Provides some additional PDF and HTML documentation for graphviz.

%if %{SMYRNA}
%package smyrna
Summary:                Graphviz interactive graph viewer

%description smyrna
Smyrna is a viewer for graphs in the DOT format.
%endif

%package gd
Summary:		Graphviz plugin for renderers based on gd
Requires:		%{name} = %{version}-%{release}

%description gd
Graphviz plugin for renderers based on gd.  (Unless you absolutely have to use
GIF, you are recommended to use the PNG format instead because of the better
quality anti-aliased lines provided by the cairo+pango based renderer.)

%if %{with gtk2}
%package gtk2
Summary:		Graphviz plugin for renderers based on gtk2
Requires:		%{name} = %{version}-%{release}

%description gtk2
Graphviz plugin for renderers based on gtk2.
%endif

%package graphs
Summary:		Demo graphs for graphviz

%description graphs
Some demo graphs for graphviz.

%if %{GUILE}
%package guile
Summary:		Guile extension for graphviz
Requires:		%{name} = %{version}-%{release}

%description guile
Guile extension for graphviz.
%endif


%package java
Summary:		Java extension for graphviz
Requires:		%{name} = %{version}-%{release}

%description java
Java extension for graphviz.


%package lua
Summary:		Lua extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               lua

%description lua
Lua extension for graphviz.


%if %{MING}
%package ming
Summary:		Graphviz plugin for flash renderer based on ming
Requires:		%{name} = %{version}-%{release}

%description ming
Graphviz plugin for -Tswf (flash) renderer based on ming.
%endif


%if %{OCAML}
%package ocaml
Summary:		Ocaml extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               ocaml
%description ocaml
Ocaml extension for graphviz.
%endif


%package perl
Summary:		Perl extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:		perl-libs

%description perl
Perl extension for graphviz.


%if %{PHP}
%package php
Summary:		PHP extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:	        php(zend-abi) = %{?php_zend_api}%{?!php_zend_api:UNDEFINED}
Requires:	        php(api) = %{?php_core_api}%{?!php_core_api:UNDEFINED}

%description php
PHP extension for graphviz.
%endif


%package python3
Summary:		Python 3 extension for graphviz
Requires:		%{name} = %{version}-%{release}
Provides:               python3dist(gv) = %{version}
Provides:               python%{python3_version}dist(gv) = %{version}

%description python3
Python 3 extension for graphviz.


%if %{ARRRR}
%package R
Summary:		R extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               R-core
%description R
R extension for graphviz.
%endif

%package ruby
Summary:		Ruby extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               ruby

%description ruby
Ruby extension for graphviz.

%if %{SHARP}
%package sharp
Summary:		C# extension for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               mono-core
%description sharp
C# extension for graphviz.
%endif


%package tcl
Summary:		Tcl extension & tools for graphviz
Requires:		%{name} = %{version}-%{release}
Requires:               tcl >= 8.3
Requires:               tk

%description tcl
Various tcl packages (extensions) for the graphviz tools.

%package go
Summary:                Go extension for graphviz
Requires:               %{name} = %{version}-%{release}, golang

%description go
Go extension for graphviz.


%prep
%autosetup -p1
find -type f -regex '.*\.\(c\|h\)$' -exec chmod a-x {} ';'


%build
autoreconf -fi

sed -i 's|for try_java_include in|& %{java_home}/include/ %{java_home}/include/linux/|' configure
sed -i 's|expand(|expand(RbConfig::|' config/config_ruby.rb
sed -i 's|sitearchdir|vendorarchdir|' config/config_ruby.rb

export CPPFLAGS=-I`ruby -e "puts File.join(RbConfig::CONFIG['includedir'], RbConfig::CONFIG['sitearch'])" || echo /dev/null`

%configure --with-x --disable-static --disable-dependency-tracking \
        --without-mylibgd --with-ipsepcola --with-pangocairo \
        --with-gdk-pixbuf --with-visio --disable-silent-rules --enable-lefty \
%if ! %{LASI}
        --without-lasi \
%endif
%if %{without gtk2}
        --without-gtk \
        --without-gtkgl \
        --without-gtkglext \
        --without-glade \
%endif
%if ! %{GTS}
        --without-gts \
%endif
%if ! %{SMYRNA}
        --without-smyrna \
%endif
%if ! %{SHARP}
        --disable-sharp \
%endif
%if ! %{OCAML}
        --disable-ocaml \
%endif
%if ! %{MING}
        --without-ming \
%endif
%if ! %{ARRRR}
        --disable-r \
%endif
%if ! %{DEVIL}
        --without-devil \
%endif
%if ! %{QTAPPS}
        --without-qt \
%endif
%if %{GUILE}
        --enable-guile=yes \
%else
        --enable-guile=no \
%endif
        --enable-go=yes \
        %{nil}

# delete rpath
sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make_build CFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fno-strict-overflow %{?FFSTORE}" \
  CXXFLAGS="$RPM_OPT_FLAGS -fno-strict-aliasing -fno-strict-overflow %{?FFSTORE}"

%if %{without bootstrap}
make doxygen
%endif

%install
# note: docdir DO NOT NEED %%{buildroot}
%make_install docdir=%{_docdir}/%{name} \
	      pkgconfigdir=%{_libdir}/pkgconfig

find %{buildroot} -type f -name "*.la" -exec rm -f {} ';'

install -m0644 README %{buildroot}%{_docdir}/%{name}


%if %{PHP}
%{__mkdir_p} %{buildroot}%{_sysconfdir}/php.d
%{__cat} << __EOF__ > %{buildroot}%{_sysconfdir}/php.d/%{ini_name}
; Enable %{name} extension module
extension=gv.so
__EOF__
%endif

find %{buildroot}%{_datadir}/%{name}/demo -type f -exec chmod a-x {} ';'

mv %{buildroot}%{_datadir}/%{name}/demo %{buildroot}%{_docdir}/%{name}/

find %{buildroot}%{_docdir}/%{name}/demo -type f -name "*.py" -exec mv {} {}.demo ';'

rm -f %{buildroot}%{_bindir}/dot_builtins

pushd %{buildroot}%{_docdir}/%{name}
for f in prune gvgen.1 gc.1 dot.1 cluster.1
do
  if [ -f $f.pdf ]
  then
    qpdf --empty --static-id --pages $f.pdf -- $f.pdf.$$
    mv -f $f.pdf.$$ $f.pdf
  fi
done
popd

# python 3
install -pD tclpkg/gv/.libs/libgv_python3.so %{buildroot}%{python3_sitearch}/_gv.so
install -p tclpkg/gv/gv.py %{buildroot}%{python3_sitearch}/gv.py

touch %{buildroot}%{_libdir}/graphviz/config%{pluginsver}

if [ "%{_prefix}" != "/usr" ]; then
  cp -ru %{buildroot}/usr/* %{buildroot}%{_prefix}/
  rm -rf %{buildroot}/usr/*
fi

mkdir -p %{buildroot}%{_datadir}/%{name}/examples

%ifarch loongarch64
mkdir -p $RPM_BUILD_ROOT/%{_libdir}/lua/
mv $RPM_BUILD_ROOT/usr/lib/lua/gv.so $RPM_BUILD_ROOT/usr/lib64/lua/gv.so
%if !%{PHP}
rm $RPM_BUILD_ROOT/%{php_extdir}/gv.so
rm $RPM_BUILD_ROOT/%{_mandir}/man3/gv.3php*
%endif
%endif

%check
%if %{PHP}
LD_LIBRARY_PATH=%{buildroot}%{_libdir} \
php --no-php-ini \
    --define extension_dir=%{buildroot}%{_libdir}/graphviz/php/ \
    --define extension=libgv_php.so \
    --modules | grep gv
%endif



%transfiletriggerin -- %{_libdir}/graphviz
%{_bindir}/dot -c 2>/dev/null || :

%transfiletriggerpostun -- %{_libdir}/graphviz
%{_bindir}/dot -c 2>/dev/null || :

%files
%doc %{_docdir}/%{name}
%{_bindir}/*
%dir %{_libdir}/graphviz
%{_libdir}/*.so.*
%{_libdir}/graphviz/*.so.*
%{_mandir}/man1/*.1*
%{_mandir}/man7/*.7*
%dir %{_datadir}/graphviz
%exclude %{_docdir}/%{name}/*.html
%exclude %{_docdir}/%{name}/*.pdf
%exclude %{_docdir}/%{name}/demo
%{_datadir}/graphviz/gvpr
%ghost %{_libdir}/graphviz/config%{pluginsver}

%if %{QTAPPS}
%{_datadir}/graphviz/gvedit
%endif

%exclude %{_libdir}/graphviz/*/*
%exclude %{_libdir}/graphviz/libgvplugin_gd.*
%if %{with gtk2}
%exclude %{_libdir}/graphviz/libgvplugin_gtk.*
%exclude %{_libdir}/graphviz/libgvplugin_gdk.*
%endif
%if %{DEVIL}
%exclude %{_libdir}/graphviz/libgvplugin_devil.*
%endif
%if %{MING}
%exclude %{_libdir}/graphviz/libgvplugin_ming.*
%exclude %{_libdir}/graphviz/*fdb
%endif
%if %{SMYRNA}
%exclude %{_bindir}/smyrna
%exclude %{_mandir}/man1/smyrna.1*
%endif

%files devel
%{_includedir}/graphviz
%{_libdir}/*.so
%{_libdir}/graphviz/*.so
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man3/*.3.*


%if %{DEVIL}
%files devil
%{_libdir}/graphviz/libgvplugin_devil.so.*
%endif


%files doc
%doc %{_docdir}/%{name}/*.html
%doc %{_docdir}/%{name}/*.pdf
%doc %{_docdir}/%{name}/demo

%if %{SMYRNA}
%files smyrna
%{_bindir}/smyrna
%{_datadir}/%{name}/smyrna
%{_mandir}/man1/smyrna.1*
%endif

%files gd
%{_libdir}/graphviz/libgvplugin_gd.so.*

%if %{with gtk2}
%files gtk2
%{_libdir}/graphviz/libgvplugin_gtk.so.*
%{_libdir}/graphviz/libgvplugin_gdk.so.*
%endif

%files graphs
%dir %{_datadir}/graphviz
%{_datadir}/graphviz/graphs


%if %{GUILE}
%files guile
%{_libdir}/graphviz/guile/
%{_mandir}/man3/gv.3guile*
%endif


%files java
%{_libdir}/graphviz/java/
%{_mandir}/man3/gv.3java*


%files lua
%{_libdir}/graphviz/lua/
%{_libdir}/lua*/*
%{_mandir}/man3/gv.3lua*


%if %{MING}
%files ming
%{_libdir}/graphviz/libgvplugin_ming.so.*
%{_libdir}/graphviz/*fdb
%endif


%if %{OCAML}
%files ocaml
%{_libdir}/graphviz/ocaml/
%{_mandir}/man3/gv.3ocaml*
%endif

%files perl
%{_libdir}/graphviz/perl/
%{_libdir}/perl*/*
%{_mandir}/man3/gv.3perl*


%if %{PHP}
%files php
%config(noreplace) %{_sysconfdir}/php.d/%{ini_name}
%{_libdir}/graphviz/php/
%{php_extdir}/gv.so
%{_datadir}/php*/*
%{_mandir}/man3/gv.3php*
%endif


%files python3
%{python3_sitearch}/*
%{_mandir}/man3/gv.3python*


%if %{ARRRR}
%files R
%{_libdir}/graphviz/R/
%{_mandir}/man3/gv.3r.*
%endif

%files ruby
%{_libdir}/graphviz/ruby/
%{_libdir}/*ruby*/*
%{_mandir}/man3/gv.3ruby*


%if %{SHARP}
%files sharp
%{_libdir}/graphviz/sharp/
%{_mandir}/man3/gv.3sharp*
%endif

%ifnarch loongarch64
%files tcl
%{_libdir}/graphviz/tcl/
%{_libdir}/tcl*/*
%{_mandir}/man3/*.3tcl*
%endif

%files go
%{_libdir}/graphviz/go/
%{_mandir}/man3/gv.3go.*

%changelog
* Thu May 16 2024 Pengda Dou <doupengda@loongson.cn> - 9.0.0-3
- [Type] bugfix
- [DESC] fix loongarch64 build error problem

* Sun Feb 18 2024 Shuo Wang <abushwang@tencent.com> - 9.0.0-2
- backport patch to fix CVE-2023-46045:
- gvc: detect plugin installation failure and display an error

* Tue Jan 09 2024 Upgrade Robot <upbot@opencloudos.org> - 9.0.0-1
- Upgrade to version 9.0.0

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.50.0-7
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.50.0-6
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 18 2023 Wang Guodong <gordonwwang@tencent.com> - 2.50.0-5
- Rebuilt for librsvg2 2.56.90

* Thu Aug 03 2023 cunshunxia <cunshunxia@tencent.com> - 2.50.0-4
- Rebuilt for tcl 8.6.13

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.50.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.50.0-2
- Rebuilt for OpenCloudOS Stream 23

* Mon Nov 14 2022 rockerzhu <rockerzhu@tencent.com> - 2.50.0-1
- Initail build
